import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

public class CommunicatorInstance extends CommIO
{
    String name;
    Process process;
    boolean IS_NEW;
    boolean SMP_LOOP = false;
    boolean HALTING = false;
    boolean PRE_SENT = false;
    boolean THREAD_INPUT = false;
    boolean on = false;
    boolean PARSE_LINE = false;
    long START_TIME = 0;
    long LAST_INPUT = 0;
    JScrollPane JSP = null;
    ColorPane COLOR_PANE;
    JTextArea TEXT_AREA = null;
    
    public CommunicatorInstance (ComradesFrame cf)
    {
	super (cf);
	CF = cf;
	cf.COMM_INST = this;
	LAST_INPUT = new Date ().getTime (); // HACK
	StartInstance ();
    }

    public String GetFenMoves () 
    {
	MoveTree MT = CF.BOARD_PANEL.POS.MOVE_TREE;
	int R = CF.BOARD_PANEL.POS.ReversibleCount;
	ComradesNode T = MT.NOW;
	for (int i = 0; i < R && T.getParent () != null; i++)
	    T = T.MainLineParent;
	BoardPosition BP = new BoardPosition (MT.START); // copy
	ComradesNode N = MT.ROOT;
	while (N != T) // HACK
	    {
		BP.MakeMove32 (N.mainline.move, N.mainline.fancy, false);
		N = N.MainLineNode;
	    }
	String S = "fen " + BP.GetFEN () + " moves";
	while (N != MT.NOW)
	    {
		BP.MakeMove32 (N.mainline.move, N.mainline.fancy, false);
		S += " " + BP.GetDirect (N.mainline.move);
		N = N.MainLineNode;
	    }
	return S;
    }

    public void SaveBook ()
    {SendTo ("savebook", true);
     CF.SAVE_BUTTON.setBackground(Color.yellow); CF.SAVE_BUTTON.revalidate();}

////////////////////////////////      ////////////////////////////////

    public boolean DirectCommunicatory ()
    {
	process = null;
	try
            {
		process = Runtime.getRuntime ().exec (CF.RUN_COMMAND);
            }
        catch (IOException io_exc)
            {
		System.out.println("Didn't find it: " + CF.RUN_COMMAND);
		System.exit(1);
                return false;
            }
        READER = new BufferedReader (new InputStreamReader (process.getInputStream ()));
        WRITER = new PrintWriter (new OutputStreamWriter (process.getOutputStream ()));
	Runtime.getRuntime().addShutdownHook (new KillProcess (process, this));
        SleepFor (100); // 1/10 second delay
	int delay=1000;
	if (CF.WIN_TREE) delay=100000; // could be complicated
	if (!WaitForThroughPut ("LOSING CHESS", delay, false))
	    {
		process.destroy ();
		System.out.println("No header");
		System.exit(1);
		return false;
	    }
        return true;
    }

    public void DisplayInstance ()
    {
	CF.INSTANCE_BOX.removeAll ();
	COLOR_PANE = new ColorPane ();
	//	COLOR_PANE.setEditable (false);
	COLOR_PANE.setFont(new Font ("Monospaced", 0, 9));
	JSP = new JScrollPane (COLOR_PANE);
        JSP.setVerticalScrollBarPolicy (JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	JSP.setHorizontalScrollBarPolicy (JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	JSP.setMinimumSize (new Dimension (360, 200));
	JSP.setPreferredSize (new Dimension (360, 200));
	CF.INSTANCE_BOX.add (JSP);
	CF.INSTANCE_BOX.revalidate (); // attend // For the necessary: "re"
	CF.INSTANCE_BOX.repaint (); // and too ?
    }

////////////////////////////////      ////////////////////////////////

    public String AttendForm (String S, BoardPosition BP, int i)
    {
	String R = new String ("");
	if ((i == 0) && !BP.WTM)
	    R += BP.MOVE_NUMBER + "...";
	if (BP.WTM)
	    R += "" + BP.MOVE_NUMBER + ".";
	if (S.equals("NULL"))
	{BP.MakeMove(0xfedc); R+="NULL"; BP.MakeNormal(); return R;}
	int w = BP.FindMove (S);
	if (w == -1) // do err ?
	    return R;
	R += BP.move_list_annotated[w];
	BP.MakeMove (w);
	BP.MakeNormal ();
	return R;
    }

    public void RedrawContainer()
    {int x=0;
	while (true)
            {
                while (!IsReady ()) {SleepFor(10); x++;}
                String L = DemandLine ();
                if (L.equals ("QUERY COMPLETE")) break;
		if (L.equals("Book Query Complete")) break;
		if (L.startsWith("Queue:")) continue;
		if (L.startsWith("line:"))
		{if (SMP_LOOP) System.out.println(L); continue;}
		if (L.startsWith("Stopping")) continue;
		if (L.startsWith("ROOT OUTPUT")) continue;
		if (L.startsWith("Solved!")) continue;
		CF.AddToContainer(L);
		if (!SMP_LOOP) System.out.println(L);
		if (x>1500) {System.out.println("REDRAW ERROR"); break;} // 15s
	    }
	CF.INSTANCE_BOX.revalidate();
	CF.INSTANCE_BOX.repaint();
    }

    public void PassiveParse()
    {
	if (SMP_LOOP)
	    {	
		while (true)
		    {
			while (!IsReady ()) SleepFor (10);
			String L = DemandLine ();
			if (L.startsWith ("BOOK ")) break;
			if (L.equals ("SMP loop complete"))
			{ SMP_LOOP = false;
			  CF.SPIN_BUTTON.setBackground(Color.cyan);
			  CF.SPIN_BUTTON.repaint(); Query(); return; }
		    }
		CF.RenewContainer();
		RedrawContainer();	
	    }
    }

    public String GetMoveList()
    {
	MoveTree MT = CF.BOARD_PANEL.POS.MOVE_TREE;
	BoardPosition BP = new BoardPosition (MT.START); // copy
	//	if (!BP.GetFEN().equals
	//	    ("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w - - 0 1"))
	//  return null;
	ComradesNode N= MT.ROOT; String S="";
	while (N != MT.NOW)
	    {
		BP.MakeMove32 (N.mainline.move, N.mainline.fancy, false);
		S += " " + BP.GetDirect (N.mainline.move);
		N = N.MainLineNode;
	    }
	return S;
    }

    public void Parser (String S)
    {if (S.equals("SMP loop complete"))
     {CF.SPIN_BUTTON.setBackground(Color.cyan); CF.SPIN_BUTTON.repaint();}
     if (S.startsWith("CPUS is")) CF.AddToContainer(S);
     if (S.startsWith("BOOK SAVE"))
     {CF.SAVE_BUTTON.setBackground(Color.yellow); CF.SAVE_BUTTON.revalidate();
      System.out.println(S); CF.SAVE_BUTTON.repaint();}
     if (S.startsWith("status")) CF.AddToContainer(S);}

    public void ParseLine (String S)
    {
        PARSE_LINE = true;
        Parser (S);     // switch parser : xboard ?
        PARSE_LINE = false;
    }

    public void ThreadInput ()
    {
        THREAD_INPUT = true;
        while (IsReady ())
            ParseLine (DemandLine ());
        LAST_INPUT = new Date ().getTime ();
        THREAD_INPUT = false;
    }

    public void MakeRoot()
    {
	SendTo ("root"+GetMoveList(),true);
	SendTo ("resume",true);
    }

    public void SpinLoop()
    {
	if (SMP_LOOP)
	    {
		SendTo ("STOP",true);
		SMP_LOOP = false;
		CF.SPIN_BUTTON.setBackground(Color.lightGray);
		CF.SPIN_BUTTON.repaint();
		return;
	    }
	String S = GetMoveList();
	SendTo ("spinloop " + S, true);
	CF.SPIN_BUTTON.setBackground(Color.green);
	CF.SPIN_BUTTON.repaint();
	SMP_LOOP = true;
    }

    public void Query ()
    {
	if (SMP_LOOP) return;
	if (IsReady() && (CF.CPU_COUNT!=0 || CF.CLUSTER)) ThreadInput();
	CF.RenewContainer();
	if (CF.CPU_COUNT!=0 || CF.CLUSTER || CF.WIN_TREE)
	{String S = GetMoveList(); if (S.length()==0) S=" ";
	 if (CF.UTILITY) while (IsReady()) DemandLine();
	 if (CF.CLUSTER || CF.UTILITY) SendTo ("getinfo" + S, true);
	 else SendTo ("query " + S, true);}
	RedrawContainer();
    }

    boolean INSTANCE=false;
    public void InstanceThread () /* internal ? */
    {
	if (INSTANCE) return;
	if (!IsReady() && CF.CPU_COUNT!=0) return;
	INSTANCE=true;
	if (SMP_LOOP)
	    {
		PassiveParse();
		INSTANCE=false;
		return;
	    }
	Query();
	try {Thread.sleep(25);} catch (InterruptedException e) {}
        if (IsReady() && CF.CPU_COUNT!=0) ThreadInput ();
	INSTANCE=false;
    }

////////////////////////  ////////////////////////  ////////////////////////  

    public void StartInstance ()
    {
	if (!DirectCommunicatory ())
	    return;
	DisplayInstance ();
	CF.LOAD_INSTANCE = false;
	Query();
	CF.BOARD_PANEL.POS.MOVE_TREE.PaintPanel ();
        CF.BoardPositionChanged ();
        CF.BOARD_PANEL.repaint ();
    }

    public class EmptyPanel extends JPanel // HACK
    {
        public EmptyPanel ()
        {
        }

        public Dimension getPreferredSize ()
        {
            return new Dimension (400, 400);
        }

        public Dimension getMinimumSize ()
        {
            return new Dimension (400, 400);
        }
    }
}
