
#include "losing.h"

#define DATA_IS_TRANS(A,x) (((A[x].data&(1U<<31)))==(1U<<31))
#define DATA_GET_NODE(A,x) (A[x].data&0x3fffffff)
#define SET_CHILD(A,x) (A[x].data|=(1U<<30))

static uint32 iLookupWinHash(typePOS *POS,uint32 n,tWIN *W)
{uint64 u,Z=POS->DYN->HASH; uint32 k=Z&W->MASK; if (!k) k++;
 while ((u=W->TRANS[k].key))
 {if (u==Z) return W->TRANS[k].node; k++; if (k==(W->MASK+1)) k=1;}
  W->LIST[W->num++]=k; W->TRANS[k].key=Z; W->TRANS[k].node=n; return 0;}

static uint32 iwin_step
(typePOS *POS,PN_NODE *TREE,uint32 NODE,tWIN *W,uint32 wn)
{uint32 u,c,last,x; uint16 mv; WIN_NODE *WIN; WIN=W->WIN;
 SET_CHILD(WIN,wn); wn++; last=wn; c=TREE[NODE].child;
 if (TREE[c].good && TREE[c].bad) goto LOOP; // ignore non-WL
 if (!TREE[NODE].bad && !TREE[c].bad) goto LOOP; // win -> loss
 mv=TREE[c].move; WIN[wn].move=mv; x=TREE[c].trans;
 MakeMoveCheck(POS,mv,FALSE); // what if this fails, due to rep?
 if ((u=iLookupWinHash(POS,wn,W))) WIN[wn++].data=(1U<<31)|u;
 else if (TREE[x].child) wn=iwin_step(POS,TREE,x,W,wn); else wn++;
 UnmakeMove(POS,mv,TRUE); if (!TREE[NODE].bad) return wn; // need only 1 win
LOOP:
 while ((c=TREE[c].sibling))
 {if (TREE[c].good && TREE[c].bad) continue;
  if (!TREE[NODE].bad && !TREE[c].bad) continue; // win -> loss
  mv=TREE[c].move; MakeMoveCheck(POS,mv,0); WIN[wn].move=mv; x=TREE[c].trans;
  if (DATA_IS_TRANS(WIN,last)) WIN[last].data|=(1U<<30);
  else WIN[last].data|=wn; last=wn;
  if ((u=iLookupWinHash(POS,wn,W))) WIN[wn++].data=(1U<<31)|u;
  else if (TREE[x].child) wn=iwin_step(POS,TREE,x,W,wn); else wn++;
  UnmakeMove(POS,mv,TRUE); if (!TREE[NODE].bad) return wn;} return wn;}

static void clear_trans(tWIN *W)
{int u; for (u=0;u<W->num;u++) W->TRANS[W->LIST[u]].key=0;}

static int get_move_list(typePOS *POS,tWIN *W)
{int u=0; typeDYNAMIC *D = POS->DYN_ROOT + 1;
 while (D != POS->DYN) {W->ML[u++]=(D+1)->mv; D++;} return u;}

void do_wintree(typePOS *POS,PN_NODE *TREE,uint32 node,tWIN *W)
{W->WIN[0].data=W->WIN[0].move=0; W->num=0; // node might not be trans value!
 W->WIN[0].data=iwin_step(POS,TREE,TREE[node].trans,W,0)|(1<<30);
 W->WIN[0].move=get_move_list(POS,W); clear_trans(W);}

// White losses and Black wins could be rep

// each machine should just have its own 100M-node WIN and 128M-entry TRANS
// and evict the latter upon completion (from 100M-entry LIST)
// this takes 3.2GB or about, so I don't make it thread-wise (there is a LOCK)
