
#include "losing.h"

// #include <signal.h>

static uint32 NEXT_PAGE; static uint32 *CHILD_LIST;

static void new_child(uint32 p,uint32 c)
{uint32 ptr=16*p,u,v; if (!p) return;
 while (TRUE)
 {for (u=ptr,v=0;v<15;u++,v++) if (!CHILD_LIST[u]) {CHILD_LIST[u]=c; return;}
  if (!CHILD_LIST[u])
  {CHILD_LIST[u]=NEXT_PAGE; CHILD_LIST[16*NEXT_PAGE]=c; NEXT_PAGE++; return;}
  ptr=16*CHILD_LIST[u];}}

static void do_child(PN_NODE *TREE,uint32 p)
{uint32 ptr=16*p,s; uint32 LIST[256],WHICH[256]; int u,v,w=0,t; if (!p) return;
 if (0) printf("Finding child for %d %d %d\n",p,TREE[p].good,TREE[p].bad);
 while (TRUE)
 {for (u=ptr,v=0;v<15 && CHILD_LIST[u];u++,v++) LIST[w++]=CHILD_LIST[u];
  if (v<15 || !CHILD_LIST[u]) break; ptr=16*CHILD_LIST[u];}
 for (u=0;u<w;u++) WHICH[u]=0;
 for (u=0;u<w;u++)
 {s=TREE[LIST[u]].sibling; if (!s) continue;
  for (t=0;t<w;t++) if (LIST[t]==s) WHICH[t]=1;}
 for (u=0;u<w;u++) if (!WHICH[u])
 {if (0) printf("Found %d for %d\n",LIST[u],p); TREE[p].child=LIST[u];}}

static void repair_children(PN_NODE *TREE) // 0x100000 extra not always enough
{uint32 sz=TREE[0].size,u,num=16*(sz+0x100000+sz/16); NEXT_PAGE=sz;
 CHILD_LIST=malloc(num*sizeof(uint32)); for (u=0;u<num;u++) CHILD_LIST[u]=0;
 for (u=2;u<sz;u++) new_child(TREE[u].parent,u);
 printf("NEXT_PAGE %d\n",NEXT_PAGE);
 for (u=2;u<sz;u++)
  if (TREE[u].parent && !TREE[TREE[u].parent].child)
    do_child(TREE,TREE[u].parent);
 printf("Repaired children\n"); free(CHILD_LIST);}

////////////////////////////////////////////////////////////////////////

static uint32 *TRANS_LIST;

static void new_trans(uint32 p,uint32 c)
{uint32 ptr=16*p,u,v;
 while (TRUE)
 {for (u=ptr,v=0;v<15;u++,v++) if (!TRANS_LIST[u]) {TRANS_LIST[u]=c; return;}
  if (!TRANS_LIST[u])
  {TRANS_LIST[u]=NEXT_PAGE; TRANS_LIST[16*NEXT_PAGE]=c; NEXT_PAGE++; return;}
  ptr=16*TRANS_LIST[u];}}

static void make_loop(PN_NODE *T,uint32 n)
{uint32 ptr=16*n,last=n,u,v;
 if (T[n].loop) printf("Loop? %d %d %d %d\n",n,T[n].loop,T[n].good,T[n].bad);
 while (TRUE)
 {for (u=ptr,v=0;v<15 && TRANS_LIST[u];u++,v++)
  {T[last].loop=TRANS_LIST[u]; last=TRANS_LIST[u];}
  if (v<15 || !TRANS_LIST[u]) break; ptr=16*TRANS_LIST[u];} T[last].loop=n;}

// should do this by hash ?
static void repair_loops(PN_NODE *T)
{uint32 u,k,sz=T[0].size,num=16*(sz+0x100000); NEXT_PAGE=sz;
 TRANS_LIST=malloc(num*sizeof(uint32)); for (u=0;u<num;u++) TRANS_LIST[u]=0;
 for (k=2;k<sz;k++) if (!T[k].loop && T[k].trans!=k && T[k].flags&4)
  new_trans(T[k].trans,k);
 printf("NEXT PAGE %d\n",NEXT_PAGE);
 for (k=2;k<sz;k++) if (!T[k].loop && T[k].trans!=k && T[k].flags&4)
  make_loop(T,T[k].trans); printf("Repaired loops\n"); free(TRANS_LIST);}

static void forward_trans(PN_NODE *T)
{uint32 n,u,sz=T[0].size;
 for (u=2;u<sz;u++)
 {n=T[u].trans; while (n!=T[n].trans) n=T[n].trans; T[u].trans=n;
  if (T[u].hash!=T[n].hash) printf("TRANS ERROR %d %d\n",n,u);}}

////////////////////////////////////////////////////////////////////////

static uint8 *SOLVED; static uint32 *NEW,*TRACK; static uint32 new=0,track=0;
static void solved_loop(PN_NODE *T,uint32 n) // NEW is not the best name...
{uint32 t,k; t=T[n].trans; if (SOLVED[t]) return; SOLVED[t]=1; NEW[new++]=t;
 k=T[t].loop; if (!k) return;
 while (k!=t) {if ((!T[k].bad && !T[t].bad) || (!T[k].good && !T[t].good))
               {SOLVED[k]=1; NEW[new++]=k;} k=T[k].loop;}}

static void get_terminal_nodes(PN_NODE *T)
{uint32 term=0,unknown=0,u,sz=T[0].size;
 for (u=2;u<sz;u++) if (known_find(T[u].hash)!=-1) T[u].child=0; // hack
 for (u=2;u<sz;u++) // what if terminal pos is in 4pc TB or patt?
 {if ((T[u].flags&16 && !T[u].bad) || (!(T[u].flags&16) && !T[u].good))
   if ((!T[u].child) && (T[u].trans==u))
   {if (known_find(T[u].hash)==-1)
    {printf("unKNOWN %d 0x%016llx\n",u,T[u].hash); unknown++;}
    else {solved_loop(T,u); term++;}}}
 printf("TERMINAL nodes %d UNKNOWN %d\n",term,unknown);}

static void backtrack_step(PN_NODE *T,uint32 n)
{uint32 c,p=T[n].parent;
 if (T[p].flags&16)
 {if (T[p].bad || T[p].size || T[T[p].trans].size) return;
  T[p].size=n; T[T[p].trans].size=n; TRACK[track++]=p;}
 else
 {if (T[p].good || T[p].size || T[T[p].trans].size) return; c=T[p].child;
  if (!SOLVED[c]) return; while ((c=T[c].sibling)) if (!SOLVED[c]) return;
  T[p].size=1; T[T[p].trans].size=n; TRACK[track++]=p;}}

static void do_backtrack(uint32 v,PN_NODE *T)
{uint32 u;
 while (TRUE)
 {printf("New count %d\n",new);
  for (u=0;u<new;u++) backtrack_step(T,NEW[u]); new=0;
  printf("Track count %d\n",track);
  for (u=0;u<track;u++) solved_loop(T,TRACK[u]); track=0;
  if (SOLVED[v]) break; if (!new) break;}}

////////////////////////////////////////////////////////////////////////

#define DATA_IS_TRANS(A,x) (((A[x].data&(1U<<31)))==(1U<<31))
#define DATA_GET_NODE(A,x) (A[x].data&0x3fffffff)
#define SET_CHILD(A,x) (A[x].data|=(1U<<30))

static tTRANS* TRANS; static uint64 TRANS_MASK;

static uint32 LookupWinHash(typePOS *POS,uint32 n)
{uint64 u,Z=POS->DYN->HASH; uint32 k=Z&TRANS_MASK; if (!k) k++;
 while ((u=TRANS[k].key))
 {if (u==Z) return TRANS[k].node; k++; if (k==(TRANS_MASK+1)) k=1;}
 TRANS[k].key=Z; TRANS[k].node=n; return 0;}

static void assure_is_child(PN_NODE *TREE,uint32 p,uint32 c)
{uint32 n; if (TREE[c].parent!=p) printf("Parent loss? %d %d\n",c,p);
 n=TREE[p].child; if (n==c) return;
 while ((n=TREE[n].sibling)) if (n==c) return;
 printf("Did not find %d %d\n",p,c);}

static uint32 win_step
(typePOS *POS,PN_NODE *TREE,uint32 NODE,WIN_NODE *WIN,uint32 wn,uint16 *SKIP)
{uint32 u,c,last,x; uint16 mv; int sk=0; SET_CHILD(WIN,wn); wn++;
 while ((mv=SKIP[sk])) {WIN[wn].data=wn+1; WIN[wn++].move=SKIP[sk++]^0xf000;}
 SKIP[0]=0; last=wn; c=TREE[NODE].child;
 if (!TREE[NODE].bad && TREE[NODE].size>1) c=TREE[NODE].size; // size is hack
 if (0) assure_is_child(TREE,NODE,c); // printf("win_step %d %d\n",NODE,wn);
 if (TREE[c].good && TREE[c].bad) goto LOOP; // ignore non-WL
 if (!TREE[NODE].bad && !TREE[c].bad) goto LOOP; // win -> loss
 mv=TREE[c].move; WIN[wn].move=mv; x=(TREE[c].size<=1 || 1)?TREE[c].trans:c;
 if (TREE[c].size<=1) x=TREE[c].trans;
 MakeMoveCheck(POS,mv,FALSE); // what if this fails, due to rep?
 if ((u=LookupWinHash(POS,wn))) WIN[wn++].data=(1U<<31)|u;
 else if (TREE[x].child) wn=win_step(POS,TREE,x,WIN,wn,SKIP); else wn++;
 UnmakeMove(POS,mv,TRUE); if (!TREE[NODE].bad) return wn; // need only 1 win
 LOOP:
 while ((c=TREE[c].sibling))
 {if (TREE[c].good && TREE[c].bad) continue;
  if (!TREE[NODE].bad && !TREE[c].bad) continue; // win -> loss
  mv=TREE[c].move; WIN[wn].move=mv; x=(TREE[c].size<=1 || 1)?TREE[c].trans:c;
  MakeMoveCheck(POS,mv,FALSE); // what if this fails, due to rep?
  if (DATA_IS_TRANS(WIN,last)) WIN[last].data|=(1U<<30);
  else WIN[last].data|=wn; last=wn;
  if ((u=LookupWinHash(POS,wn))) WIN[wn++].data=(1U<<31)|u;
  else if (TREE[x].child) wn=win_step(POS,TREE,x,WIN,wn,SKIP); else wn++;
  UnmakeMove(POS,mv,TRUE); if (!TREE[NODE].bad) return wn;} return wn;}

// do not follow trans if "size" is bigger than 1 ?

////////////////////////////////////////////////////////////////////////

static uint32 splice_prolog(typePOS *POS,uint16 *ML)
{uint32 w=0; typeDYNAMIC *D; D=POS->DYN_ROOT+1;
 while (D!=POS->DYN) {ML[w++]=(D+1)->mv; D++;} return w;}

static uint32 TreeMove(PN_NODE *T,uint16 mv,uint32 n)
{uint32 c=T[n].child; if (!c) return 0; if (T[c].move==mv) return c;
 while ((c=T[c].sibling)) {if (T[c].move==mv) return c;} return 0;}

static uint32 align_booktreeZ(PN_NODE *T,typePOS *POS,uint32 n)
{typeDYNAMIC *D; D=POS->DYN_ROOT+1;
 while (D!=POS->DYN && n)
 {D++; n=TreeMove(T,D->mv,n); n=T[n].trans;} return n;}

void wintree_direct(typePOS *POS,char *STR)
{WIN_STRUCT *WS; WIN_NODE *W; uint16 ML[1024];
 int w=0; uint64 Z=POS->DYN->HASH;
 if (known_find(Z)==-1) {printf("not KNOWN\n"); return;}
 WS=WintreeKnown(Z); W=WS->W; free(WS->MOVE_LIST);
 printf("Copying direct solution from KNOWN file 0x%016llx\n",Z);
 typeDYNAMIC *D; D=POS->DYN_ROOT+1; while (D!=POS->DYN) {D++; ML[w++]=D->mv;}
 W[0].move=w; // char STR[64]; strcpy(STR,"PROOFS/WINTREE.win");
 SaveWinTree(W,ML,w,STR); printf("Wrote to %s\n",STR); free(W); free(WS);}

WIN_STRUCT* try_wintree(PN_NODE *T,typePOS *POS,char *ml,uint16 *SKIP)
{uint32 t,u,sz,w,node; WIN_NODE *WIN; uint16 *LIST;
 init_position(POS,"startpos"); parse_moves(POS,ml);
 node=align_booktreeZ(T,POS,1); printf("NODE is %d\n",node);
 forward_trans(T); sz=T[0].size; for (u=1;u<sz;u++) T[u].size=0;
 repair_children(T); fflush(stdout); repair_loops(T); fflush(stdout);
 NEW=malloc(sz*sizeof(uint32)); TRACK=malloc(sz*sizeof(uint32));
 SOLVED=malloc(sz); for (u=0;u<sz;u++) NEW[u]=TRACK[u]=SOLVED[u]=0;  
 new=track=0; get_terminal_nodes(T); do_backtrack(node,T);
 printf("SOLVED[%d]=%d\n",node,SOLVED[node]);
 if (!SOLVED[node]) {free(NEW); free(TRACK); free(SOLVED); return NULL;}
 ////////////////////////////////////////////////////////////////////////
 WIN=malloc(sizeof(WIN_NODE)*T[0].size);
 for (t=0;t<T[0].size;t++) WIN[t].data=WIN[t].move=0;
 TRANS_MASK=2<<BSR(1000+(11*T[0].size)/10);
 TRANS=CALLOC(TRANS_MASK,sizeof(tTRANS));
 printf("TRANS table at %lld entries\n",TRANS_MASK); fflush(stdout);
 for (t=0;t<TRANS_MASK;t++) TRANS[t].key=TRANS[t].node=0; TRANS_MASK--;
 LIST=malloc(1024*sizeof(uint16)); w=splice_prolog(POS,LIST);
 node=T[node].trans; WIN[0].data=win_step(POS,T,node,WIN,0,SKIP)|(1<<30);
 char STR[64]; strcpy(STR,"PROOFS/WINTREE.win");
 SaveWinTree(WIN,LIST,w,STR); printf("Wrote to %s\n",STR); fflush(stdout);
 free(NEW); free(TRACK); free(SOLVED); free(TRANS);
 WIN_STRUCT *WS; WS=malloc(sizeof(WIN_STRUCT));
 WS->W=WIN; WS->MOVE_LIST=LIST; return WS;}
